c      SUBROUTINE COMPTON(HELICITY, CROSS, E_END, P, TH, CSTHCM,X,Y)

	Program Compton
c
c adapted from Felix Kuemmell to test the Compton generator
c
c  to compile:	 f77 -o compton compton.f ran2.f
c	

	
	IMPLICIT NONE
	
	integer ii,nrounds,idum
	
	REAL EBEAM, EGAMMA, ALPHA_X, ALPHA_Y, BETA_X, BETA_Y, ETA_X
	REAL ETA_Y, DIST, CSTHCM, PHI, GAMMA, K_I, K_F, CONST, SIGMA_0
	REAL SIGMA_1, SIGMA_2Y, SIGMA_2Z, CROSS, CROSSMAX, E_END, TH
	REAL HORIZ, VERT, RR, X, Y, M_E, R_E, W
	REAL L, N, M, HLIN, HELICITY, PTRANS, PLONG, P(3)
	REAL VALUE, GARNDM, G
	REAL DGRD,ATAN, RG32, ran2, rounds,steps,jacob,pi

	pi=acos(0.)*2.

cwl	DGRD=ATAN(1.0)/45.0
	
	M_E=0.510999                    !ELECTRON MASS
	R_E=2.818                       !ELECTRON RADIUS
        EBEAM=27.5                      !BEAM PARAMETERS
        EGAMMA=2.33                     !IN MM
        ALPHA_X=0.62
        ALPHA_Y=-1.51
        BETA_X=8500
        BETA_Y=24900
        ETA_X=3.4E-5
        ETA_Y=0.065*ETA_X
	HLIN=0
	PTRANS=0
	PLONG=1
        DIST=54000                      !DISTANCE TO DET(MM)
	W=1.                            !DUMMY
	idum=123456789

        write(6,'(a,$)') ' Enter number of rounds, <10000> '
        read(5,'(i)') nrounds
        if(nrounds.eq.0)  nrounds= 10000
        write(6,*) 'Number of rounds = ',nrounds

	do ii=1,nrounds
	
c     takes into account the different cross sections
cwl        CALL GRNDM (HELICITY, 1)
cwl        IF (HELICITY .GT. 0.469509) THEN
        IF (ran2(idum) .GT. 0.469509) THEN
           HELICITY=+1.0
        ELSE
           HELICITY=-1.0
        ENDIF

cwl	   CALL GRNDM (L, 1)
cwl	   PHI=360.D0*L*DGRD
cwl 300    CALL GRNDM (N, 1)
 300    continue
        CSTHCM=2.D0*ran2(idum)-1.
c	CALL HFILL(1, CSTHCM, 1., 1.)
cwl	IF (CSTHCM .EQ. 1.0 .OR. CSTHCM .EQ. -1.0) THEN
cwl        GOTO 300             !GENERATE NEXT EVENT
cwl         ENDIF 

c     calculate the cross section for longitudinal polarized e
	GAMMA=EBEAM*1000/(M_E)
	K_I=2*GAMMA*EGAMMA*0.000001/(M_E)
	K_F=1/(1-CSTHCM + 1/K_I)
	CONST=0.5*R_E**2*K_F**2/(K_I**2)		! [fm^2/GeV]
	const=const*10					! [mb/GeV]
	SIGMA_0=CONST*((1+CSTHCM**2) + (K_I-K_F)*(1-CSTHCM))
C	SIGMA_1=CONST*COS(2*PHI)*(1-CSTHCM**2)
C	SIGMA_2Y=-CONST*K_F*SIN(PHI)*SQRT(1-CSTHCM**2)*(1-CSTHCM)
	SIGMA_2Z=-CONST*(1-CSTHCM)*(K_I+K_F)*CSTHCM
	CROSS=SIGMA_0 + SIGMA_2Z*(HELICITY)*(PLONG)
C    1  SIGMA_1*(HLIN) + SIGMA_2Y*(HELICITY)*PTRAN
	TH=ACOS(CSTHCM)

	CROSSMAX=79.4116     !maximum cross section in CM *10
cwl 	CALL GRNDM (M, 1)
cwl	IF (M .GT. CROSS/CROSSMAX) THEN
	IF (ran2(idum) .GT. CROSS/CROSSMAX) THEN
	GOTO 300
	ENDIF

c     energy of compton photon
	E_END=EBEAM*K_f*(1-CSTHCM)			!IN GEV
	jacob = m_e**2/(2.*EGAMMA*0.001*(e_end-ebeam)**2)*2.*pi
	cross=cross*jacob

	if(helicity.gt.0)  then
	  write(16,101) e_end, cross, jacob, th, csthcm
	else
	  write(26,101) e_end, cross, jacob, th, csthcm  
	endif
101	format(5f12.5)

	enddo

	goto 999

c     beam smearing
        HORIZ=SQRT(ETA_X*(BETA_X+DIST*(DIST*(1+ALPHA_X**2)
     $    /BETA_X - 2*ALPHA_X)))
        VERT=SQRT(ETA_Y*(BETA_Y+DIST*(DIST*(1+ALPHA_Y**2)
     $    /BETA_Y - 2*ALPHA_Y)))

	G=RG32(W)               !gaussian radom generator
        RR=DIST*SQRT(1.0-CSTHCM**2)/(GAMMA*(1-CSTHCM))
        X=RR*COS(PHI)-HORIZ*G
        Y=RR*SIN(PHI)-VERT*G

c	CALL HFILL(1, E_END, W, E_END)

c     momentum of comton photon
	P(1)=E_END*X/(SQRT(X**2+Y**2+DIST**2))
	P(2)=E_END*Y/(SQRT(X**2+Y**2+DIST**2))
	P(3)=E_END*DIST/(SQRT(X**2+Y**2+DIST**2))

	X=X/10.
        Y=Y/10.
	
 999	continue
	END
