      SUBROUTINE COMPTON(HELIC,CROSS,E_gamma,P,th_gamma,CSTHCM,X,Y,DIST)

c
c adapted from Felix Kuemmell to test the Compton generator
c W. Lorenzon, 15-June-1999	

	
	IMPLICIT NONE
 	
	integer ii,nrounds,idum
	
	REAL EBEAM, EPHOTON, E_gamma
	REAL CSTHCM, PHI, GAMMA, K_I, K_F, CONST, SIGMA_0
	REAL SIGMA_1, SIGMA_2Y, SIGMA_2Z, CROSS, CROSSMAX, TH
	REAL M_E, R_E, DIST
	REAL K, L, N, M, HLIN, HELIC, PTRANS, PLONG, P(3)
	REAL VALUE, GARNDM, G, th_gamma
	REAL DGRD,ATAN, RG32, ran2, rounds,steps,jacob,pi
	real x,y,rr

	pi=acos(0.)*2.

	DGRD=ATAN(1.0)/45.0
	
	M_E=0.510999                    !ELECTRON MASS
	R_E=2.818                       !ELECTRON RADIUS
      EBEAM=27.5                      
      EPHOTON=2.33                     
	HLIN=0
	PTRANS=0
	PLONG=1
cwl	DIST=5400						! dist in cm  	
	idum=123456789

cc     takes into account the different cross sections
        CALL GRNDM (K, 1)
        IF (K .GT. 0.469446) THEN
ccwl        IF (ran2(idum) .GT. 0.469446) THEN
           HELIC=+1.0
        ELSE
           HELIC=-1.0
        ENDIF
c
	  CALL GRNDM (L, 1)
	  PHI=360.d0*L*DGRD
 300    CALL GRNDM (N, 1)
        CSTHCM=2.d0*N-1.
ccwl 300    continue
ccwl        CSTHCM=2.0*ran2(idum)-1.

c     calculate the cross section for longitudinal polarized e
	GAMMA=EBEAM*1000/(M_E)
	K_I=2*GAMMA*EPHOTON*0.000001/(M_E)
	K_F=1/(1-CSTHCM + 1/K_I)
	CONST=0.5*R_E**2*K_F**2/(K_I**2)		! [fm^2/GeV]
	const=const*10.							! [mb/GeV]
	SIGMA_0=CONST*((1+CSTHCM**2) + (K_I-K_F)*(1-CSTHCM))
C	SIGMA_1=CONST*COS(2*PHI)*(1-CSTHCM**2)
C	SIGMA_2Y=-CONST*K_F*SIN(PHI)*SQRT(1-CSTHCM**2)*(1-CSTHCM)
	SIGMA_2Z=-CONST*(1-CSTHCM)*(K_I+K_F)*CSTHCM
	CROSS=SIGMA_0 + SIGMA_2Z*(HELIC)*(PLONG)
C    1  SIGMA_1*(HLIN) + SIGMA_2Y*(HELIC)*PTRAN
	TH=ACOS(CSTHCM)

	CROSSMAX=79.4116     !maximum cross section in e CM *10
 	CALL GRNDM (M, 1)
	IF (M .GT. CROSS/CROSSMAX) THEN
ccwl	IF (ran2(idum) .GT. CROSS/CROSSMAX) THEN
	GOTO 300
	ENDIF

c     energy of compton photon
	E_gamma=EBEAM*K_f*(1-CSTHCM)			!IN GEV
	jacob = m_e**2/(2.*EPHOTON*0.001*(E_gamma-ebeam)**2)*2.*pi
	cross=cross*jacob

c     beam position at calorimeter

	th_gamma=SQRT(1.0-CSTHCM**2)/(GAMMA*(1-CSTHCM))
      RR=DIST*th_gamma
      X=RR*COS(PHI)
      Y=RR*SIN(PHI)

	return
	END
