      SUBROUTINE GUKINE
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C   
C    GUKINE is a user routine to define the Kinematics, Vertex and     C
C    particle.                                                         C   
C                                                                      C   
C		W. Lorenzon,     March 21/94                                 C   
C		J. Seibert       1998                                        C   
C		W. Lorenzon,     January 18/99                               C   
C		W. Lorenzon,     June 16/99                                  C   
C                                                                      C   
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC   
C
C
      IMPLICIT none
C
      INCLUDE 'gckine.cmn'
      INCLUDE 'gconst.cmn'
      INCLUDE 'gcunit.cmn'
      INCLUDE 'gcflag.cmn'
      INCLUDE 'user.cmn'
C
C  Local variables
C
      INTEGER ITYPE,NVTX,NT,ISEED

	real rndm,nn,thlab
      REAL UBUF(1)

      data vertex /0.0,0.0,0.0/
      data plab /0.0,0.0,0.0/
	data dist/5400./

      IF(ICOMPT.EQ.1) THEN
c
c  set offset in x (horizontal) and y (vertical)
c
cwl       yoff = 2.0 * (float (int (rndm(iseed)*11) )/10.)  
cwl	 xoff = 0.   
         yoff = 0.
         xoff = 2.0 * (float (int (rndm(iseed)*11) )/10.)  
c
c  produce particles according to Compton cross section. long.pol. e-
c
	 call compton(HELIC,CROSS,egamma,PLAB,thlab,CSTHCM,XPOS,YPOS,DIST)
	 itype = 1				! =1: photon
c
c  smear particle positions due to beam emmitance
c
	 call beam_smear(XSMEAR,YSMEAR,DIST)
	 x = xpos - xsmear + xoff
	 y = ypos - ysmear + yoff
       vertex(1)= X
       vertex(2)= Y
	 vertex(3)= -1.
       CALL GSVERT(VERTEX,0,0,UBUF,1,NVTX)
       if(IDEBUG.EQ.1) then
	  write(6,*)'vertex=',vertex, egamma,helic,cross,xpos,
     1                      ypos,xoff,yoff,xsmear,ysmear,thlab
	 endif
c     momentum of Compton photon
	 PLAB(1)=egamma*X/(SQRT(X**2+Y**2+DIST**2))
	 PLAB(2)=egamma*Y/(SQRT(X**2+Y**2+DIST**2))
	 PLAB(3)=egamma*DIST/(SQRT(X**2+Y**2+DIST**2))
 
	ELSE
       yoff = 2.1 * (rndm(iseed)*2.-1.)  
	 xoff = 0.   

	 vertex(1) = xoff   
       vertex(2) = yoff  
       vertex(3) = -20.00
       CALL GSVERT(VERTEX,0,0,UBUF,1,NVTX)
C
       ITYPE  = int(MYKIN(1))
c
c  this was introduced by J. Seibert to run his code. 
c
        open(22,file='egamma.cfg',status='old')
          read(22,*)nn
        close(22)
        if(nn.gt.14) egamma=rndm(iseed)*15.0			
        if(nn.le.14) then
	    PLAB(3)=nn*1.0
	    egamma=PLAB(3)
	  endif
	ENDIF
      CALL GSKINE(PLAB,ITYPE,NVTX,UBUF,1,NT)
C
C   Kinematics debug (controlled by ISWITCH(1)
C
      IF(IDEBUG.EQ.1) THEN
        IF(ISWIT(1).EQ.1) THEN
          CALL GPRINT('VERT',0)
          CALL GPRINT('KINE',0)
        ENDIF
      ENDIF

      RETURN
      END
