      SUBROUTINE GUSTEP                                                         
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                             C
C     GUSTEP is a user routine called at the end of each tracking step.       C
C     INWVOL is non-zero when the track has reached a volume boundary.        C 
C     ISTOP is non-zero if the track has stopped.                             C
C                                                                             C
C     ==>Called by : GTRACK                                                   C
C                                                                             C
C         W. Lorenzon      March 21/94										C
C		W. Lorenzon,     January 18/99										C
C                                                                             C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      IMPLICIT NONE
C
      INTEGER INEWOL,NAMOLD,NUBOLD,IP,N,NUBUF,NTBEAM,NTTARG
C
      REAL UBUF(10),EMAS2,TE, ENOUT, DEOUT
C
      include 'gconst.cmn'
      include 'gcflag.cmn'
      include 'gcphys.cmn'
      include 'gckine.cmn'
      include 'gcking.cmn'
      include 'gctrak.cmn'
      include 'gctmed.cmn'
      include 'gccuts.cmn'
      include 'gcvolu.cmn'
      include 'gcnum.cmn'
      include 'user.cmn'
      include 'gcunit.cmn'

C
      DATA NAMOLD/0/,NUBOLD/0/
C
C     Something generated?
C
      IF(NGKINE.GT.0) THEN
        DO 300 I=1,NGKINE
300        CALL GSKING(I)
      ENDIF
C
      enout = gekin
c
c  convert energy scale from GeV into MeV
c
      DEOUT = DESTEP*1000.
C 
C  no restrictions on this histogram
C
      desumt = desumt + deout
C
CCC     ask for particles that enter a new volume which is a detector
CCC     but not those that are created in the volume:
CCC     IF(INWVOL.EQ.1 .AND. ISVOL.NE.0 .AND. NSTEP.NE.0) THEN
C
ccc      write(lout,*) ' number of SCI ',number(3),isvol,IPART
c   fill detector variables
c 
      IF(ISVOL.NE.0) THEN                         ! ask for detector
c
       IF(NUMBER(3).LE.12) THEN                   
        IF(IPART.EQ.2) THEN
          dEpos = dEpos + deout
        ELSEIF(IPART.EQ.3) THEN
          dEele = dEele + deout	
        ENDIF                                                                  
c
c  this part was used when we had the TransPol detector modelled
c  -- upper and lower half --
c
c       IF(NUMBER(3).LE.12) THEN                   ! lower half of detector
c        IF(IPART.EQ.2) THEN
c          dEpos_d = dEpos_d + deout
c        ELSEIF(IPART.EQ.3) THEN
c          dEele_d = dEele_d + deout	
c        ENDIF                                                                  
c
c       ELSEIF(NUMBER(3).LE.24) THEN               ! upper part of detector
c        IF(IPART.EQ.2) THEN
c          dEpos_u = dEpos_u + deout
c        ELSEIF(IPART.EQ.3) THEN
c          dEele_u = dEele_u + deout	
c        ENDIF      
c
       ELSE
          WRITE(LOUT,*) ' Problem with detector copies'
       ENDIF
      ENDIF                                                                     
C 
      call gdebug
      RETURN
      END
