      SUBROUTINE UGINIT
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C     UGINIT initializes the GEANT/USER program and reads data cards   C
C                                                                      C
C         W. Lorenzon    March  21/94                                  C
C		W. Lorenzon,   January 18/99                                 C   
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      IMPLICIT NONE
C
      INTEGER IVALUE,ITEXT,ISTAT
C
      CHARACTER*4 MEC
C
      CHARACTER*40  FFCARDS
      CHARACTER*6  RANDOM
      CHARACTER*40 CARDNAME
      CHARACTER*100 FILNAM
      LOGICAL FEXIST
      CHARACTER*80 TEXT
      DIMENSION ITEXT(20)
C
      include 'gclist.cmn'
      include 'gcflag.cmn'
      include 'gcunit.cmn'
      include 'gconst.cmn'
      include 'gctrak.cmn'
      include 'user.cmn'
C
      EQUIVALENCE (TEXT,ITEXT(1))
C
      DATA MEC/'MSTP'/
C
      DATA ITEXT/20*'    '/
C
C     Open FLUKA data file
C
      FILNAM='flukaaf.dat'
      OPEN(22,FILE=FILNAM,STATUS='OLD',READONLY)
C
C     Initialise GEANT variables
C
      CALL GINIT

      do i=1,7
        ihit(i)=0
        do j=1,200
          hhit(i,j)=0.
        enddo
      enddo
C
      CALL DEFCAR
C
      CALL APFFKY
      write(lout,*) ' NFAC =', NFAC
C
C
C  Open the HBOOK histogram file   
C
      call hropen(34,'bsname','calo.hbk','NX',1024,istat)
      if(istat.ne.0) then
        write(lout,*) ' Error: Bad return from HROPEN'
        stop
      endif
C
      CALL FFGET('LINP',IVALUE)
      FFCARDS = 'pol.ffcard'
      OPEN(UNIT=IVALUE,FILE=FFCARDS,STATUS='UNKNOWN',ERR=998)
      READ(IVALUE,1)TEXT
      WRITE(LOUT,1)TEXT
1     FORMAT(A80)
C
      CALL GFFGO
      CLOSE(IVALUE)
C
      IF(ISWIT(3).EQ.1)THEN
        RANDOM = 'RANDOM'
        CALL GETENV(RANDOM,CARDNAME)
        INQUIRE(FILE=CARDNAME,EXIST=FEXIST)
        IF(FEXIST)THEN
          OPEN(UNIT=18,FILE=CARDNAME,STATUS='OLD',ERR=996)
        ELSE
          GOTO 996
        END IF
      END IF
C
C     Initialize data structures
C
      CALL GZINIT
C
C     Open I/O buffers
C
        CALL GPART     !Define standard particle data
        CALL GMATE     !Define standard material data
        CALL UGMED     !Define additional materials
        CALL UGEOM     !Define the geometrical setup
C
      CALL GPHYSI    !Compute cross section and energy loss tables
C
C     Initialize standard histograms
C
      IF(NHSTA.GT.0) then 
        write(lout,*) 'Booking standard histograms.'
        CALL GBHSTA
      end if
      call gubook  ! Book the histograms
      CALL TIMEX(TMS)

C
      RETURN
C
996   WRITE(LOUT,*)' Error opening RANDOM file! '
      GOTO 999
998   WRITE(LOUT,*)' Error opening FFCARD file! '
999   STOP
      END
C
