      SUBROUTINE UGMED
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                      C
C     UGMED is a user routine to define geometry and tracking media.   C
C                                                                      C
C     W. Lorenzon     March  21/94                                     C
C                                                                      C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C
      IMPLICIT NONE

      include 'gcunit.cmn'
      include 'gcflag.cmn'

      INTEGER ISVOL, IFIELD

      REAL FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN

      REAL AA, ZZ, DDENS, RRADL, AABSL, UBUF
      INTEGER NWBUF
      CHARACTER*20 CCHNAMA


      REAL ZLG(6),ALG(6),WLG(6)    
      REAL ZSS(3),ASS(3),WSS(3)    
      REAL ZPS(2),APS(2),WPS(2)    
      REAL ZDE(3),ADE(3),WDE(3)    
      REAL ZCK(4),ACK(4),WCK(4)    
C
C
C   Define USER Mixtures and Compounds
C
C             SF6 dense PB glass mixture parameters 
C   
c      DATA ALG/ 207.19,  39.102,  28.088,  22.99, 15.999,  74.922/  
c      DATA ZLG/  82.00,  19.00,  14.00,  11.00,  8.00,  33.00/  
c      DATA WLG/ .65994, .00799, .126676, .0040073,.199281, .00200485/   
c    
c      CALL GSMIXT(17,'SF6 PB GLASS',ALG,ZLG,5.2,6,WLG) 

C             F101 (like SF2) dense PB glass mixture parameters
C
C                lead  potassium silicon sodium  oxygen cerium
      DATA ALG/ 207.19,  39.102,  28.088,  22.99, 15.999, 140.13/
      DATA ZLG/  82.00,  19.00,  14.00,  11.00,  8.00,  58.00/
      DATA WLG/ 0.46397, 0.04383, 0.19863, 0.00193, 0.27536, 0.01628/

      CALL GSMIXT(17,'F101 PB GLASS',ALG,ZLG,3.86,6,WLG)
C
C             304 stainless 
C   
      DATA ASS/  55.847, 51.9961, 58.69  / ! Fe, Cr, Ni
      DATA ZSS/  26., 24., 28./ 
      DATA WSS/  .703, .202, .095 /

      CALL GSMIXT(18,'SS-403',ASS,ZSS,8.0,3,WSS) 

C
C             Plastic Scintillator
C   
      DATA APS/  12.010, 1.010 /           ! C, H
      DATA ZPS/  6., 1. /
      DATA WPS/  .476, .524 /

      CALL GSMIXT(19,'PLASTIC SCINT.',APS,ZPS,1.032,2,WPS) 

C
C             DENSIMET17
C   
      DATA ADE/  183.850, 58.710, 55.850/           ! W, Ni, Fe
      DATA ZDE/  74., 28., 26. /
      DATA WDE/  .905, .065, .030 /

      CALL GSMIXT(20,'DENSIMET17',ADE,ZDE,17.16,3,WDE) 

C
C             NBW Cerenkov crystal -- NaBi(WO4)2 compound parameters
C   
      DATA ACK/  200.980, 183.850, 22.990, 16.000 /  ! Bi, W, Na, O
      DATA ZCK/   83.,     74.,    11.,     8. /
      DATA WCK/    1.,      2.,     1.,     8. /

      CALL GSMIXT(21,'NBW crystal',ACK,ZCK,7.57,-4,WCK) 

      CALL GFMATE(21, CCHNAMA ,AA, ZZ, DDENS, RRADL, AABSL, UBUF, NWBUF)
      write (lout,*) 'NBW out:',CCHNAMA ,AA, ZZ, DDENS, RRADL, AABSL
C
C   Define USER tracking media parameters
C
      fieldm =  0.
      isvol  =  0       ! sensitive volume flag (if non zero)
      ifield =  0.
c      tmaxfd = 10.
c      dmaxms = 0.50
c      deemax = 0.20
      epsil  = 0.001
c      stmin  = 0.80

      CALL GSTMED(1, 'DEFAULT MEDIUM VACUUM',16,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      CALL GSTMED(2, 'Iron                 ',10,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)

      CALL GSTMED(3, '304 stainless steel  ',18,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      CALL GSTMED(4, 'Tungsten special     ',20,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      CALL GSTMED(5, 'Pb                   ',13,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      CALL GSTMED(6, 'Aluminium$', 9 , 0 , IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)

      isvol  =  1       ! sensitive volume flag (if non zero)

      CALL GSTMED(10, 'Detector             ',15,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)

      CALL GSTMED(11, 'F101 Pb Glass Detector',17,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      CALL GSTMED(12, 'Scintillator         ',19,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      CALL GSTMED(13, 'NBW crystal',21,ISVOL,IFIELD,
     *               FIELDM,TMAXFD,DMAXMS,DEEMAX,EPSIL,STMIN, 0,0)
      
      RETURN
      END
    
